#ifdef GL_ES
precision mediump float;
#define LOWP		lowp
#define MEDIUMP		mediump
#define HIGHP		highp
#else
#define LOWP
#define MEDIUMP
#define HIGHP
#endif


varying LOWP vec4 v_fragmentColor;
varying HIGHP vec2 v_texCoord0;
varying HIGHP vec2 v_texCoord1;

// uniform variables provided by the application
uniform sampler2D CC_Texture0;

uniform vec4 u_color1;
uniform vec4 u_color2;


void main(void) {
	if (v_fragmentColor.a > 0.0) {
		//discard;
	    LOWP float noise0 = texture2D(CC_Texture0, v_texCoord0).r;
	    LOWP float noise1 = texture2D(CC_Texture0, v_texCoord1).r;
	    LOWP float noise  = (noise0 * noise1) + (-1.0);

	    LOWP float mod_alpha = (v_fragmentColor.a * 2.0) + noise;
	    LOWP vec3  mod_color = (v_fragmentColor.rgb * 2.0) + vec3(noise);

	    gl_FragColor = vec4(mix(v_fragmentColor.rgb, v_fragmentColor.rgb, clamp(mod_color, vec3(0.0), vec3(1.0))), mod_alpha);
//	  gl_FragColor = vec4(1.0, 1.0, 1.0, v_fragmentColor.a);
	} else {
	  gl_FragColor = v_fragmentColor;
	}
}