#ifdef GL_ES
precision mediump float;
#define LOWP		lowp
#define MEDIUMP		mediump
#define HIGHP		highp
#else
#define LOWP
#define MEDIUMP
#define HIGHP
#endif

varying MEDIUMP vec2 v_texCoord;
varying LOWP vec4 v_fragmentColor;

uniform sampler2D CC_Texture0;
uniform float pixelSizeX;
uniform float pixelSizeY;
uniform float delta;
uniform vec4 u_innerColor;
uniform vec2 u_bottomLeft;
uniform vec2 u_topRight;
uniform int u_borderWith;
uniform float u_innerBorderPerc;

void main()
{
	float a = 0.0;
	vec4 col = texture2D(CC_Texture0, v_texCoord);
	vec4 mixedCol = vec4(0,0,0,0);
	gl_FragColor = mixedCol;
	if(col.a <= 0.3 && v_texCoord.x >= u_bottomLeft.x && v_texCoord.y >= u_bottomLeft.y && v_texCoord.x <= u_topRight.x && v_texCoord.y <= u_topRight.y) {
	  int borderWidth = u_borderWith;
	  int tmp = 0;
	  borderWidth += tmp;
	  for(int i = 1 + tmp; i <= borderWidth; i++) {
	    float it = float(i - tmp);
	    vec2 cor1 = vec2(v_texCoord.x + pixelSizeX * it, v_texCoord.y);
	    vec2 cor2 = vec2(v_texCoord.x - pixelSizeX * it, v_texCoord.y);
	    vec2 cor3 = vec2(v_texCoord.x, v_texCoord.y + pixelSizeY * it);
	    vec2 cor4 = vec2(v_texCoord.x, v_texCoord.y - pixelSizeY * it);
	    
	    vec2 cor5 = vec2(v_texCoord.x + pixelSizeX * it, v_texCoord.y + pixelSizeY * it);
	    vec2 cor6 = vec2(v_texCoord.x - pixelSizeX * it, v_texCoord.y + pixelSizeY * it);
	    vec2 cor7 = vec2(v_texCoord.x + pixelSizeX * it, v_texCoord.y - pixelSizeY * it);
	    vec2 cor8 = vec2(v_texCoord.x - pixelSizeX * it, v_texCoord.y - pixelSizeY * it);
	    
	    if(texture2D(CC_Texture0, cor1).a > 0.3 || texture2D(CC_Texture0, cor2).a > 0.3 ||
	      texture2D(CC_Texture0, cor3).a > 0.3 || texture2D(CC_Texture0, cor4).a > 0.3 ||
	      texture2D(CC_Texture0, cor5).a > 0.3 || texture2D(CC_Texture0, cor6).a > 0.3 ||
	      texture2D(CC_Texture0, cor7).a > 0.3 || texture2D(CC_Texture0, cor8).a > 0.3) {
		int h = int(float(borderWidth) * u_innerBorderPerc);
		int dis = h - i;
		if(i < h) {
		  a = ((1.0 / float(borderWidth)) * float(i));
		} else {
		  a = 1.0 - ((1.0 / float(borderWidth)) * float(i));
		  if(h == i) {
		    a = 0.8;
		  }
		}
		gl_FragColor = (vec4(mix(v_fragmentColor.rgb, u_innerColor.rgb, a), 1.0) * a) * delta;
		break;
	    }
	  }
	}
}