#ifdef GL_ES
precision mediump float;
#define LOWP		lowp
#define MEDIUMP		mediump
#define HIGHP		highp
#else
#define LOWP
#define MEDIUMP
#define HIGHP
#endif

varying MEDIUMP vec2 v_texCoord;
varying LOWP vec4 v_fragmentColor;

uniform sampler2D CC_Texture0;
uniform float pixelSizeX;
uniform float pixelSizeY;
uniform float delta;
uniform vec4 u_innerColor;
uniform vec2 u_bottomLeft;
uniform vec2 u_topRight;
uniform int u_borderWith;
uniform float u_innerBorderPerc;

void main()
{
	vec4 col = texture2D(CC_Texture0, v_texCoord);
	gl_FragColor = vec4(0,0,0,0);
	if(col.a > 0.1 && v_texCoord.x >= u_bottomLeft.x && v_texCoord.y >= u_bottomLeft.y && v_texCoord.x <= u_topRight.x && v_texCoord.y <= u_topRight.y) {
	   gl_FragColor = vec4(v_fragmentColor.rgb, (col.a * 0.0));
	}
}